clear
close all
clc

addpath(pwd)

load('global_datiret_day.mat') 

panel_gl = log( (ee+vv).^2 );
n_j=201;
n_us=336;
n_eu=293;
n_gl=n_j+n_us+n_eu;
bl=[    1 n_j;  n_j+1 n_j+n_us;  n_j+n_us+1 n_gl];

ret_j = y(:,bl(1,1):bl(1,2));
ret_us = y(:,bl(2,1):bl(2,2));
ret_eu = y(:,bl(3,1):bl(3,2));

%%
fprintf([repmat('=',1,100), '\n'])
disp([repmat(' ',1,30),'1: JP,   2: US,  3: EU'])
fprintf([repmat('=',1,100), '\n'])

%% dimension of returns factor subspaces

q = 4;

qj  = 1;
qus = 3;
qeu = 1;

qjus  = 4;
quseu = 3;
qjeu  = 2;

%% returns

fprintf([repmat('_',1,100), '\n'])
disp([repmat(' ',1,40), 'returns', repmat(' ',1,40)])
fprintf([repmat('_',1,100), '\n'])

M = 5;

kestimate_3_blocks_SS(ret_j,ret_us,ret_eu,q,qj,qus,qeu,qjus,quseu,qjeu,M)  

%% dimension of volatilities factor subspaces
panel_j  = panel_gl(:,bl(1,1):bl(1,2)); 
panel_us = panel_gl(:,bl(2,1):bl(2,2));
panel_eu = panel_gl(:,bl(3,1):bl(3,2));

q = 2;

qj  = 1;
qus = 2;
qeu = 2;

qjus  = 2;
quseu = 2;
qjeu  = 2;

%% volatilities

fprintf([repmat('_',1,100), '\n'])
disp([repmat(' ',1,40), 'volatilities', repmat(' ',1,40)])
fprintf([repmat('_',1,100), '\n'])

M = 20;

kestimate_3_blocks_SS(panel_j,panel_us,panel_eu,q,qj,qus,qeu,qjus,quseu,qjeu,M)