clear
close all
clc

addpath(pwd)

load('speu350')
time = dates(2:end,:);
clearvars -except time

load('global_datiret_day.mat')

panel_gl = log( (ee+vv).^2 );
n_j=201;
n_us=336;
n_eu=293;
n_gl=n_j+n_us+n_eu;
bl=[    1 n_j;  n_j+1 n_j+n_us;  n_j+n_us+1 n_gl];

Time = datenum(time(end-length(panel_gl)+1:end,:));

%% subsamples 
beg_gl_cr = find(time(:,1)==2007 & time(:,2)==08 & time(:,3)==09);
end_gl_cr = find(time(:,1)==2009 & time(:,2)==06 & time(:,3)==30);
beg_eu_cr = find(time(:,1)==2010 & time(:,2)==04 & time(:,3)==27);
end_eu_cr = find(time(:,1)==2012 & time(:,2)==07 & time(:,3)==26);

stb1 = [1:beg_gl_cr-1];
trm1 = [beg_gl_cr:end_eu_cr]; 
stb2 = [end_eu_cr+1:length(Time)];

%% RETURNS

fprintf([repmat('_',1,100), '\n'])
disp([repmat(' ',1,40), 'returns', repmat(' ',1,40)])
fprintf([repmat('_',1,100), '\n'])

ret_j = y(:,bl(1,1):bl(1,2));
ret_us = y(:,bl(2,1):bl(2,2));
ret_eu = y(:,bl(3,1):bl(3,2));

% dimension of returns factor subspaces (constant all over the sample)
q = 4;

qj  = 1;
qus = 3;
qeu = 1;

qjus  = 4;
quseu = 3;
qjeu  = 2;

M = 5;

fprintf([repmat('_',1,100), '\n'])
disp([repmat(' ',1,40), 'Stable 1', repmat(' ',1,40)])
disp(['Nobs:',num2str(length(stb1))])
fprintf([repmat('_',1,100), '\n'])

kestimate_3_blocks_SS(ret_j(stb1,:),ret_us(stb1,:),ret_eu(stb1,:),q,qj,qus,qeu,qjus,quseu,qjeu,M)



fprintf([repmat('_',1,100), '\n'])
disp([repmat(' ',1,40), 'Turmoil', repmat(' ',1,40)])
disp(['Nobs:',num2str(length(trm1))])
fprintf([repmat('_',1,100), '\n'])

kestimate_3_blocks_SS(ret_j(trm1,:),ret_us(trm1,:),ret_eu(trm1,:),q,qj,qus,qeu,qjus,quseu,qjeu,M)


fprintf([repmat('_',1,100), '\n'])
disp([repmat(' ',1,40), 'Stable 2', repmat(' ',1,40)])
disp(['Nobs:',num2str(length(stb2))])
fprintf([repmat('_',1,100), '\n'])

kestimate_3_blocks_SS(ret_j(stb2,:),ret_us(stb2,:),ret_eu(stb2,:),q,qj,qus,qeu,qjus,quseu,qjeu,M)

%% VOLATILITIES
fprintf([repmat('_',1,100), '\n'])
disp([repmat(' ',1,40), 'volatilities', repmat(' ',1,40)])
fprintf([repmat('_',1,100), '\n'])

panel_j  = panel_gl(:,bl(1,1):bl(1,2)); 
panel_us = panel_gl(:,bl(2,1):bl(2,2));
panel_eu = panel_gl(:,bl(3,1):bl(3,2));

% dimension of volatilities factor subspaces (constant all over the sample)
q = 2;

qj  = 1;
qus = 2;
qeu = 2;

qjus  = 2;
quseu = 2;
qjeu  = 2;

M = 20;


fprintf([repmat('=',1,100), '\n'])
disp([repmat(' ',1,30),'1: JP,   2: US,  3: EU'])
fprintf([repmat('=',1,100), '\n'])


fprintf([repmat('_',1,100), '\n'])
disp([repmat(' ',1,40), 'Stable 1', repmat(' ',1,40)])
disp(['Nobs:',num2str(length(stb1))])
fprintf([repmat('_',1,100), '\n'])

kestimate_3_blocks_SS(panel_j(stb1,:),panel_us(stb1,:),panel_eu(stb1,:),q,qj,qus,qeu,qjus,quseu,qjeu,M)



fprintf([repmat('_',1,100), '\n'])
disp([repmat(' ',1,40), 'Turmoil', repmat(' ',1,40)])
disp(['Nobs:',num2str(length(trm1))])
fprintf([repmat('_',1,100), '\n'])

kestimate_3_blocks_SS(panel_j(trm1,:),panel_us(trm1,:),panel_eu(trm1,:),q,qj,qus,qeu,qjus,quseu,qjeu,M)


fprintf([repmat('_',1,100), '\n'])
disp([repmat(' ',1,40), 'Stable 2', repmat(' ',1,40)])
disp(['Nobs:',num2str(length(stb2))])
fprintf([repmat('_',1,100), '\n'])

kestimate_3_blocks_SS(panel_j(stb2,:),panel_us(stb2,:),panel_eu(stb2,:),q,qj,qus,qeu,qjus,quseu,qjeu,M)

