clear
clc
close all

addpath(genpath(pwd))

%% load and transform data
DS=char('nkk225', 'sp500', 'speu350');

NN=0; yy=[]; stocks=[];

for i=1:size(DS,1)
    
	ds = deblank(DS(i,:));
	load(ds)
	Y = dat;
	timeD = dates;
	YD = diff(log(Y));
	time = timeD(2:end,:);
	y = YD;
	stocks = [stocks; names];
	clear Y* dat dates names timeD 
	[T,N] = size(y);
	w = floor(0.5*sqrt(T)); 
    M_y = mean(y);
	y = y-ones(T,1)*M_y;
	y = y.*100;
	NN=NN+N;
	nc(i)=N;
	yy=[yy y];
    
end

[y, N] = deal(yy, NN);
clear yy NN

stocks = regexprep(stocks,' - PRICE INDEX','');

%% factor decomposition for returns
load('global_datiret_day', 'ee','vv')

%% compute variance proxy
panel_gl = log( (ee+vv).^2 );
[nj, nus, neu]=deal(nc(1),nc(2),nc(3));

%% Estimation

nlagsimp    = 20;          % number of lags in MA
nrepli      = 100;           % number of replication of the estimation
maxlag      = 5;            % max lag order blockwise VAR (FHLZ) and AR (idiosyncratics)
q_gl        = 2;


est=input('Estimate IRFs? \n (1) Yes \n (2) No, load results \n');
est=est==1;

if est 
    
c=input('Identification \n (1) Replicate search for the optimal rotation angle \n (2) Use optimal angle \n');
c=c==1;

if c
    theta=linspace(-pi,pi,100);
else
    theta = 2.3483;
end

if c
    for i=1:numel(theta)
        disp(['theta = ', num2str(theta(i))])
        [~,cl,u,~,xi] = fhlz_nstd2_ident(panel_gl,q_gl+1,maxlag,w,nlagsimp,1:q_gl,nrepli,theta(i));
        ssimp(i,1) = sum (cl([1:nj],1,1).^2);
        ssimp(i,2) = sum (cl([1:nj],2,1).^2);
        disp(['ssimp = [',num2str(ssimp(i,1)), ' ', num2str(ssimp(i,2)),']' ])
    end
end

if c
    [v,p] = min(ssimp);
    [~,is] = min(v);
    disp(['min ssimp = ', num2str(min(v))])
    thetastar = theta(p(is));
    [~,cl,u,~,~] = fhlz_nstd2_ident(panel_gl,q_gl+1,maxlag,w,nlagsimp,1:q_gl,nrepli,thetastar);
else
    thetastar = theta;
    [~,cl,u,~,~] = fhlz_nstd2_ident(panel_gl,q_gl+1,maxlag,w,nlagsimp,1:q_gl,nrepli,thetastar);
end


save irfs cl u

else load irfs
    
end

%% plots

wide=50;
pper=[(100-wide)/2 100-(100-68)/2];

figure
for i=1:length(pper); p11=plot(prctile(squeeze(cl(1:nj,1,:)),[pper(i)]),'r'); hold on;end
for i=1:length(pper); p21=plot(prctile(squeeze(cl(nj+1:nus+nj,1,:)),[pper(i)])    ); hold on;end
for i=1:length(pper); p31=plot(prctile(squeeze(cl(nus+nj+1:end,1,:)),[pper(i)]),'g'); hold on;end
hold off
legend([p11,p21,p31],'JP','US','EU')

figure
for i=1:length(pper); p12=plot(prctile(squeeze(cl(1:nj,2,:)),[pper(i)]),'r'); hold on; end
for i=1:length(pper); p22=plot(prctile(squeeze(cl(nj+1:nus+nj,2,:)),[pper(i)])    ); hold on;end
for i=1:length(pper); p32=plot(prctile(squeeze(cl(nus+nj+1:end,2,:)),[pper(i)]),'g'); hold on;end
hold off
legend([p12,p22,p32],'JP','US','EU')