clear all
clc
close all

addpath(genpath(pwd))

%% load and transform data
DS=char('nkk225', 'sp500', 'speu350');


NN=0; yy=[];

for i=1:size(DS,1)
    
    ds = deblank(DS(i,:));
    
    load(ds)
    Y = dat;
    timeD = dates;
    YD = diff(log(Y));
    time = timeD(2:end,:);
    y = YD;
    clear Y* dat dates names timeD      % names: mnemonics see Appendix in the paper
    [T,N] = size(y);
    days = 252;
    w = floor(0.5*sqrt(T));
    M_y = mean(y);
    y = y-ones(T,1)*M_y;
    y = y.*100;
    NN=NN+N;
    yy=[yy y];
    
end

[y, N]=deal(yy, NN);
clear yy NN
ds='global';

%% factor decomposition for returns
%% number of common factors in returns (see nfactors_returns.m)

q=4;
qq = q+1;

%% estimate common component x as in FHLZ 2013

nlagsimp = 10;          % number of lags in MA
idvar = [1:q];
nrepli = 100;           % number of replication of the estimation
maxlag = 5;     % max lag order blockwise VAR (FHLZ) and AR (idiosyncratics)


rng(1)
[x,CL,u,C1,ee] = fhlz_nstd2(y,qq,maxlag,w,nlagsimp,idvar,nrepli);
z=y(maxlag+1:end,:)-x;
ee = ee(maxlag+1:end,:);

%% estimate AR models on each idio and keep the residuals
for j=1:N
    k(j)=mybicaic(z(:,j),maxlag);
    [~,vvv{j}]=ML_VAR(z(:,j),k(j),0);
end

for j=1:N
    vv(:,j)=vvv{j}(maxlag-k(j)+1:end);
end
clear vvv

%% create unique dataset of size 2*N x T
T1 = size(ee,1);

eval(['save ',[ds,'_datiret_day'],' y x ee u vv '])
