%% Run Hallin-Liska criterion to determine the number of factors in every subpanel of returns

%%
clear all
clc
close all

addpath(genpath(pwd))

c=input('Run Hallin Liska? \n (1) yes \n (2) no \n');
c=c==1;

DS=char('nkk225', 'sp500', 'speu350');

if c
    
    NN=0; yy=[];
    
    for i=1:size(DS,1)
        
        ds = deblank(DS(i,:));
        
            load(ds)
            Y = dat;
            timeD = dates;
            YD = diff(log(Y));
            time = timeD(2:end,:);
            y = YD;
            clear Y* dat dates names timeD      % names: mnemonics see Appendix in the paper
            [T,N] = size(y);
            days = 252;
            w = floor(0.5*sqrt(T));
            M_y = mean(y);
            y = y-ones(T,1)*M_y;
            y = y.*100;
            NN=NN+N;
            yy=[yy y];
        end

        
    
    
    [panel, N]=deal(yy, NN);
    clear y yy NN
    
    clearvars -except panel c DS
    
    [T,N] = size(panel);
    w = floor(0.5*sqrt(T));
    
    
    n_j=201;
    n_us=336;
    n_eu=293;
    
    bl=[    1 n_j;  n_j+1 n_us+n_j;  n_us+n_j+1 n_us+n_j+n_eu];
    
end

K=size(DS,1);

clc

for i=1:K
    
    sel=nchoosek(1:K,i);
    nco=size(sel,1);
    
    for j=1:nco
        
        nom=[];
        if i~=K
            for ii=1:i
                nom=strcat(nom,DS(sel(j,ii),:),'_');
            end
            nom=nom(:,1:end-1); 
        else
            nom='global';
        end
        fprintf(' \n \n \t \t \t %s \n', nom)
        disp(repmat('_',1,40))
        
        %%
        if c
            subpanel=[];
            for jj=1:i
                subpanel = [subpanel    panel(:, bl(sel(j,jj),1):bl(sel(j,jj),2) ) ];
            end
            q_max=10;
            Ns=size(subpanel,2);
            c_max=1;
            cf=100;
            [nfact_ss_oo, v_nfact_ss_oo, cr_ss_oo] = numfactors_nonstd_log(subpanel, q_max, round(Ns/2), round(Ns/20), c_max,'p2', cf);
        else
            load nfact_ret_fig
            c_max=1;
            cf=100;
            cr = (1:floor(c_max*cf))'/cf;
            eval(['nfact=nfact_ss_oo_',nom,';'])
            eval(['v_nfact=v_nfact_ss_oo_',nom,';'])
            figure
            plot(cr,5*v_nfact,'b-')
            hold all
            plot(cr,nfact,'r-')
            xlabel('c')
            axis tight
            legend('S_c','q^{*T}_{c;n}')
            title(['estimated number of factors - log criterion - ' nom])
            
        end
                
        %%
        if c
            close all
            eval(['nfact_ss_oo_',nom,'=nfact_ss_oo;'])
            eval(['v_nfact_ss_oo_',nom,'=v_nfact_ss_oo;'])
            eval(['cr_ss_oo_',nom,'=cr_ss_oo;'])
        end
        
        disp(repmat('=',1,40))
        
    end
end

clear cr_ss_oo nfact_ss_oo v_nfact_ss_oo

if c
    save nfact_ret_fig nfact_ss_oo* v_nfact_ss_oo* cr_ss_oo*
end

clearvars -except *_ss_oo* 