%% projection on realized variances
clear;clc
addpath(pwd)

%% lags factors
p=23;

%%
subs = input('Choose subsample:\n (1) turmoil\n (2) stable\n');

if subs == 1
    DATA_INIZIO = '09-Aug-2007';
    DATA_FINE = '25-Jul-2012';
elseif subs == 2
    DATA_INIZIO = '26-Jul-2012';
    DATA_FINE = '31-Aug-2015';
end

mrkt = input('Choose market: \n (1) SP500 \n (2) NKK225 \n (3) FTSE 100 \n (4) EUROSTOXX 50 \n (5) DAX \n');
while mrkt~=1 && mrkt~=2 && mrkt~=3 && mrkt~=4 && mrkt~=5
    mrkt=input('\n please enter a number between 1 and 5 \n');
end

load('irfs','u')

if mrkt==1
    fprintf(['\n \n',repmat(sprintf('*'),1,30),' SP500 ',repmat(sprintf('*'),1,30),'\n \n \n'])
    mne = 'SPX2.rv';
    load sp500rv
    load('sp500','dates')
elseif mrkt==2
    fprintf([repmat(sprintf('*'),1,30),' NKK225 ',repmat(sprintf('*'),1,30),'\n'])
    mne = 'N2252.rv';
    load nkk225rv
    load('nkk225','dates')
elseif mrkt==3
    fprintf([repmat(sprintf('*'),1,30),' FTSE100 ',repmat(sprintf('*'),1,30),'\n'])
    mne = 'FTSE2.rv';
    load ftse100rv
    load('speu350','dates')
elseif mrkt==4
    fprintf([repmat(sprintf('*'),1,30),' EUROSTOXX50 ',repmat(sprintf('*'),1,30),'\n'])
    mne = 'STOXX50E.rv';
    load stoxxrv
    load('speu350','dates')
elseif mrkt==5
    fprintf([repmat(sprintf('*'),1,30),' DAX ',repmat(sprintf('*'),1,30),'\n'])
    mne = 'GDAXI2.rv';
    load daxrv
    load('speu350','dates')
end

da=dates(end-length(u)+1:end,:);

[di,ida,ido]=intersect(datenum(da),datenum(doo));

rv = rv(ido);
uv = u(ida,:);

load('bhs_dhfm_results_11_100_500','f')
pf=1;
fy=f(pf+1:end);
fx=f(1:end-pf,:);
uf = fy-fx*(fx\fy);

uf = uf(ida,:);

div=datevec(di);

Time=datenum(div);

if mrkt==1
    US_closed
elseif mrkt==2
    NKK_closed
elseif mrkt>2 
    EU_closed
end

div(ex,:)   = [];
uv(ex,:)    = [];
rv(ex)      = [];
uf(ex,:)    = [];

Time_N=datenum(div);
Time_S=datestr(Time_N);

    
for i=1:size(Time_N,1)
    START_index(i,1) = strcmp(Time_S(i,:),DATA_INIZIO);
    STOP_index(i,1) = strcmp(Time_S(i,:),DATA_FINE);
end
START = find(START_index==1);
STOP = find(STOP_index==1);

rv = rv(START:STOP);
uv = u(START:STOP,:);
uf = uf(START:STOP,:);

rvs = rv/std(rv);
rvs0=rvs;

uvs(:,1)=uv(:,1)/(std(uv(:,1)));
uvs(:,2)=uv(:,2)/(std(uv(:,2)));

for i=1:size(uf,2)
    uf(:,i)=uf(:,i)/(std(uf(:,i)));
end

%% In-sample regression: factors only
fprintf(['\n \n',repmat(sprintf('_'),1,30),' In-sample: factors only','\n'])
x=[];
for i=0:p
    x = [x uvs(p+1-i:end-i,:)];
end

rvs=rvs(p+1:end,:);

[T,n] = size(rvs);
x = [ones(T,1) x];


buvs=(x'*x)\x'*rvs;
k=length(buvs);

Rsq=var(x*buvs)/var(rvs);
adjRsq = 1-(1-Rsq)*((T-1)/(T-k-1));
disp(['adjRsq = ', num2str(adjRsq)])

e = rvs - x*buvs;
s2 = e'*e/(length(e)-k);
v = s2*inv(x'*x);

r=size(x,2)-1;
R = zeros(r,k);
for ii=1:r; R(ii,end-ii) = 1; end
R=R(:,end:-1:1);
F = (R*buvs)'*inv(R*v*R')*(R*buvs);
rej = F >  chi2inv(.99,size(R,1));


fprintf('\n \n');
disp(['F-test'])
disp(['F=',num2str(F)])
disp(['1% critical value = ',num2str(chi2inv(.99,size(R,1)))])
if rej
    disp('H0 is rejected')
else
    disp('H0 is not rejected')
end

%% Predictive regression: factors only
fprintf(['\n \n',repmat(sprintf('_'),1,30),' Predictive regression: factors only','\n'])
x=[];
for i=1:p
    x = [x uvs(p+1-i:end-i,:)];
end

rvs=rvs0(p+1:end,:);

[T,n] = size(rvs);
x = [ones(T,1) x];


buvs=(x'*x)\x'*rvs;
k=length(buvs);

Rsq=var(x*buvs)/var(rvs);
adjRsq = 1-(1-Rsq)*((T-1)/(T-k-1));
disp(['adjRsq = ', num2str(adjRsq)])

e = rvs - x*buvs;
s2 = e'*e/(length(e)-k);
v = s2*inv(x'*x);

r=size(x,2)-1;
R = zeros(r,k);
for ii=1:r; R(ii,end-ii) = 1; end
R=R(:,end:-1:1);
F = (R*buvs)'*inv(R*v*R')*(R*buvs);
rej = F >  chi2inv(.99,size(R,1));


fprintf('\n \n');
disp(['F-test'])
disp(['F=',num2str(F)])
disp(['1% critical value = ',num2str(chi2inv(.99,size(R,1)))])
if rej
    disp('H0 is rejected')
else
    disp('H0 is not rejected')
end


%% factor augmented HAR
fprintf(['\n \n',repmat(sprintf('_'),1,30),' Predictive regression: factor augmented HAR ','\n'])
pp=[0 5 22];
x=[];
for i=1:p
    x = [x uvs(p+1-i:end-i,:)];
end

for i=1:numel(pp)
    x=[x rvs0(p-pp(i):end-pp(i)-1,:)];
end

rvs=rvs0(p+1:end,:);        

[T,n] = size(rvs);
x = [ones(T,1) x];


buvs=(x'*x)\x'*rvs;
k=length(buvs);

err_fhar=rvs-x*buvs;

Rsq=var(x*buvs)/var(rvs);
adjRsq = 1-(1-Rsq)*((T-1)/(T-k-1));
disp(['adjRsq = ', num2str(adjRsq)])

e = rvs - x*buvs;
s2 = e'*e/(length(e)-k);
v = s2*inv(x'*x);

r=size(x,2)-1;
R = zeros(r,k);
for ii=1:r; R(ii,end-ii) = 1; end
R=R(:,end:-1:1);
F = (R*buvs)'*inv(R*v*R')*(R*buvs);
rej = F >  chi2inv(.99,size(R,1));


fprintf('\n \n');
disp(['F-test'])
disp(['F=',num2str(F)])
disp(['1% critical value = ',num2str(chi2inv(.99,size(R,1)))])
if rej
    disp('H0 is rejected')
else
    disp('H0 is not rejected')
end

%% factor augmented HAR (global only)
fprintf(['\n \n',repmat(sprintf('_'),1,30),' Predictive regression: factor augmented HAR (global only) ','\n'])
pp=[0 5 22];
x=[];
for i=1:p
    x = [x uvs(p+1-i:end-i,2)];
end

for i=1:numel(pp)
    x=[x rvs0(p-pp(i):end-pp(i)-1,:)];
end

rvs=rvs0(p+1:end,:);        

[T,n] = size(rvs);
x = [ones(T,1) x];


buvs=(x'*x)\x'*rvs;
k=length(buvs);

err_fharg=rvs-x*buvs;

Rsq=var(x*buvs)/var(rvs);
adjRsq = 1-(1-Rsq)*((T-1)/(T-k-1));
disp(['adjRsq = ', num2str(adjRsq)])

e = rvs - x*buvs;
s2 = e'*e/(length(e)-k);
v = s2*inv(x'*x);

r=size(x,2)-1;
R = zeros(r,k);
for ii=1:r; R(ii,end-ii) = 1; end
R=R(:,end:-1:1);
F = (R*buvs)'*inv(R*v*R')*(R*buvs);
rej = F >  chi2inv(.99,size(R,1));


fprintf('\n \n');
disp(['F-test'])
disp(['F=',num2str(F)])
disp(['1% critical value = ',num2str(chi2inv(.99,size(R,1)))])
if rej
    disp('H0 is rejected')
else
    disp('H0 is not rejected')
end

%% factor augmented HAR (MNP global only)
fprintf(['\n \n',repmat(sprintf('_'),1,30),' Predictive regression: MNP factor augmented HAR (global only) ','\n'])
pp=[0 5 22];
x=[];
for i=1:p
    x = [x uf(p+1-i:end-i,1)];
end

for i=1:numel(pp)
    x=[x rvs0(p-pp(i):end-pp(i)-1,:)];
end

rvs=rvs0(p+1:end,:);       

[T,n] = size(rvs);
x = [ones(T,1) x];


buvs=(x'*x)\x'*rvs;
k=length(buvs);

err_mnpfharg=rvs-x*buvs;

Rsq=var(x*buvs)/var(rvs);
adjRsq = 1-(1-Rsq)*((T-1)/(T-k-1));
disp(['adjRsq = ', num2str(adjRsq)])

e = rvs - x*buvs;
s2 = e'*e/(length(e)-k);
v = s2*inv(x'*x);

r=size(x,2)-1;
R = zeros(r,k);
for ii=1:r; R(ii,end-ii) = 1; end
R=R(:,end:-1:1);
F = (R*buvs)'*inv(R*v*R')*(R*buvs);
rej = F >  chi2inv(.99,size(R,1));


fprintf('\n \n');
disp(['F-test'])
disp(['F=',num2str(F)])
disp(['1% critical value = ',num2str(chi2inv(.99,size(R,1)))])
if rej
    disp('H0 is rejected')
else
    disp('H0 is not rejected')
end


%% HAR
fprintf(['\n \n',repmat(sprintf('_'),1,30),' Predictive regression: HAR ','\n'])
pp=[0 5 22];
x=[];
for i=1:numel(pp)
    x=[x rvs0(p-pp(i):end-pp(i)-1,:)];
end

rvs=rvs0(p+1:end,:);

[T,n] = size(rvs);
x = [ones(T,1) x];


buvs=(x'*x)\x'*rvs;
k=length(buvs);

err_har=rvs-x*buvs;

Rsq=var(x*buvs)/var(rvs);
adjRsq = 1-(1-Rsq)*((T-1)/(T-k-1));
disp(['adjRsq = ', num2str(adjRsq)])

e = rvs - x*buvs;
s2 = e'*e/(length(e)-k);
v = s2*inv(x'*x);

r=size(x,2)-1;
R = zeros(r,k);
for ii=1:r; R(ii,end-ii) = 1; end
R=R(:,end:-1:1);
F = (R*buvs)'*inv(R*v*R')*(R*buvs);
rej = F >  chi2inv(.99,size(R,1));


fprintf('\n \n');
disp(['F-test'])
disp(['F=',num2str(F)])
disp(['1% critical value = ',num2str(chi2inv(.99,size(R,1)))])
if rej
    disp('H0 is rejected')
else
    disp('H0 is not rejected')
end


%% Giacomini-White test: HAR vs factor augmented HAR
[~, pval]   = CPAtest(err_har.^2,err_fhar.^2,1, .05, 1);
% [~, pvalcca]   = CPAtest(err_har.^2,err_ccafhar.^2,1, .05, 1);
% [~, pvalccaf]   = CPAtest(err_ccafhar.^2,err_fhar.^2,1, .05, 1);
[~, pvalg]  = CPAtest(err_har.^2,err_fharg.^2,1, .05, 1);
[~, pvalgmnp]  = CPAtest(err_har.^2,err_mnpfharg.^2,1, .05, 1);
[~, pvalgmnpf]  = CPAtest(err_mnpfharg.^2,err_fharg.^2,1, .05, 1);
[~, pvalgf]  = CPAtest(err_fharg.^2,err_fhar.^2,1, .05, 1);
[~, pvalfmnpf]  = CPAtest(err_fhar.^2,err_mnpfharg.^2,1, .05, 1);


fprintf(['\n \n',repmat(sprintf('_'),1,70),'\n'])
disp(['Relative MSE (FHAR/HAR) = ',num2str(mean(err_fhar.^2)/mean(err_har.^2))])
% disp(['Relative MSE (ccaFHAR/HAR) = ',num2str(mean(err_ccafhar.^2)/mean(err_har.^2))])
disp(['Relative MSE (FHARg/HAR) = ',num2str(mean(err_fharg.^2)/mean(err_har.^2))])
disp(['Relative MSE (mnpFHARg/HAR) = ',num2str(mean(err_mnpfharg.^2)/mean(err_har.^2))])



disp(['Giacomini-White test: HAR vs FHAR , p-value = ', num2str(pval) ])
% disp(['Giacomini-White test: HAR vs CCA-FHAR , p-value = ', num2str(pvalcca) ])
% disp(['Giacomini-White test: CCA-FHAR vs FHAR , p-value = ', num2str(pvalccaf) ])
disp(['Giacomini-White test: HAR vs FHARG , p-value = ',num2str(pvalg)])
disp(['Giacomini-White test: HAR vs mnpFHARG , p-value = ',num2str(pvalgmnp)])
disp(['Giacomini-White test: mnpFHARG vs FHARG , p-value = ',num2str(pvalgmnpf)])
disp(['Giacomini-White test: FHARG vs FHAR , p-value = ',num2str(pvalgf)])
disp(['Giacomini-White test: mnpFHARG vs FHAR , p-value = ',num2str(pvalfmnpf)])
