function [pstarbic,pstaraic] = mybicaic(y,pmax)
if pmax
    yy=y(pmax+1:end,:);
    
    T = length(yy);
    
    bic=NaN(pmax,1);
    
    for j = 1:pmax
        
        % Lags
        LYproj = lagmatrix(y,1:j);
        LYproj = LYproj(pmax+1:end,:);
        
        % OLS ESTIMATES
        b     = LYproj \ yy;
        
        % Residuals
        res    = yy - LYproj*b;
        
%         res2   = var(res);
        res2   = cov(res);
        
%         bic(j) = log(res2) + j*log(T)/T;
        bic(j) = log(det(res2)) + j*log(T)/T;
        
        aic(j) = log(det(res2)) + 2*j/T;
%         aic(j) = log(res2) + 2*j/T;
        
    end
    
    [~,pstarbic] = min(bic);
    [~,pstaraic] = min(aic);
    
else
    pstarbic = pmax;
    pstaraic = pmax;
    
end